{{
  Setup Routines
}}

obj

  key       : "keyboard"
  vid       : "vga_40x18_rom_text"
  eeprom    : "spin_i2c_driver"
  cfg       : "configuration"
  ui        : "ui_methods"
  sf        : "strfmt"
  bsf       : "bufstrfmt"
  clock     : "clock"
  tfmt      : "tdfmt"
  bkg       : "bkg"

dat

Setup_Menu

        byte  "Header Fields", 13
        byte  "System Options", 13
        byte  "System Parameters", 13
        byte  "Comm Data Frame", 13
        byte  "Transaction Info Fields", 13
        byte  "Setup Password", 13
        byte  "Key Password", 13
        byte  "Set Clock", 13
        byte  "Exit"
        byte  0

pub Setup | c, sel, pwbuf[3]

  if byte[constant(cfg#setup_base+cfg#pwds)]
    'there is a password
    pwbuf[0] := 0
    c := ui.popupinput(string("Enter System", 13, "Password:         "), {
  } @pwbuf, constant(8 + ui#inputucase + ui#inputhide), %%002) 
    if c == $CB
      return
    if not strcomp(bsf.bufbuf(constant(cfg#setup_base+cfg#pwds),8), @pwbuf)
      'ui.flashmsg(string("Password Incorrect."), %%200, 2)
      ui.flashmsg(bsf.strcat(bsf.bufbuf(constant(cfg#setup_base+cfg#pwds),8), @pwbuf), %%200, 2)
      return

  sel := -1
  repeat
    ui.drawheader(string("Setup Menu"), 9, 3)
    case sel := ui.picklist(@setup_menu, -1, 5, sel)  
      0:
        header_setup
      1:
        sys_opt_setup
      2:
        sys_parm_setup
      3:
        if cfg.sys(cfg#Cont)
          ui.flashmsg(string("Continuous Format is Fixed.",13,"(See System Options)"), %%200, 3)
        elseif cfg.sys(cfg#sma)
          ui.flashmsg(string("SMA Format is Fixed.",13,"(See System Options)"), %%200, 3)
        else
          instrument_setup
      4:
        tif_setup
      5:
        setuppw(constant(cfg#setup_base+cfg#pwds), string("Setup"))
      6:
        setuppw(constant(cfg#setup_base+cfg#pwds+8), string("Key Weigh"))
      7:
        set_clock
      8:
        return

pub SetupPW(OldPW, PWname) | c, p, buf[3], Msg[20]

  bytemove(@buf, oldpw, 8)
  byte[@buf+8] := 0
  p := sf.str(@msg, string("Enter "))
  p := sf.str(p, pwname)
  sf.str(p, string(13, "Password:         "))
  c := ui.popupinput(@msg, @buf, constant(8 + ui#inputucase), %%002)
  if c == $cb
    return
  if strcomp(@buf, oldpw)
    return
  if byte[@buf] == 0 and byte[oldpw] <> 0
    p := sf.str(@msg, string("Do you want to disable the",13))
    p := sf.str(p, pwname)
    sf.str(p, string(" Password? (Y/N)"))
    if not ui.confirmyn(@msg, %%200)
      return
  bytemove(oldpw, @buf, 8)
  savesetup

  
pub sys_opt_setup | bits, width, c, bitpatt, sel, val

  bitpatt := long[constant(cfg#setup_base + cfg#Sys_Opt)]

  ui.drawheader(string("System Options Setup"), 5, 0)

  val := ui.DrawLetterList(cfg.SysDescStr, 5, 2)
  bits := val & $FF
  width := val >> 8 + 4 'allow for [*]
  '
  c := ui.editbits(cfg.SysDescStr, 5, 2, bitpatt)
  if c == -1
    return
  else
    long[cfg#setup_base + cfg#Sys_Opt] := c 
    savesetup
    return
   
pub sys_parm_setup | fields, width, c

  ui.drawheader(string("System Parameter Setup"), 4, 5)
  '
  if ui.multinuminput(cfg.SysParmStr, constant(cfg#setup_base + cfg#sys_parms), 4, 7, 5)
    savesetup
    clkset(128,0)  'reset needed to restart serial object

     
pub instrument_setup | v, image[20]

  repeat v from 0 to 15
    image[v] := byte[constant(cfg#setup_base + cfg#instr) + v]

  ui.drawheader(string("Instrument Data Setup"), 4, 2)
  '
  if ui.multinuminput(cfg.InstrDescStr, @image, 4, 4, 3)
    repeat v from 0 to 15
      byte[constant(cfg#setup_base + cfg#instr) + v] := image[v]
    savesetup
    return

pub header_setup | c, sel, buf[9], image[32]

  longmove(@image, constant(cfg#setup_base + cfg#headers), constant(32*4/4))

  ui.drawheader(string("Ticket Header Setup",13), 4, 2)
  repeat sel from 0 to 3
    vid.str(string(13, $C, %%2222, "    Line "))
    vid.out("1"+sel)
    vid.str(string(":",13,"    "))
    vid.str(bsf.bufbuf(@image+sel<<5,32))
  vid.str(string(13,13,"    Save Changes ",$BA,$9C))    

  sel := 0
  repeat
    case sel
      0..3:
        bytemove(@buf, bsf.bufbuf(@image+sel<<5,32), 33)
        c := ui.doinput(@buf, 4, 5+sel<<1, 32)
        if c <> $CB
          longmove(@image+sel<<5, @buf, constant(32/4))
      4:
        ui.hilite(4, 13, 15, 1)
        c := ui.waitkey
        ui.hilite(4, 13, 15, 0)
    case c
      $c2:
        'up
        sel--
        if sel < 0
          sel := 4
      $c3, $0d:
        'down
        sel++
        if sel > 4
          if c == $0d
            'save changes
            longmove(constant(cfg#setup_base + cfg#headers), @image, constant(32*4/4))
            savesetup
            return
          sel := 0
      $cb:
        if sf.bufcomp(constant(cfg#setup_base + cfg#headers), @image, 128)
          'no changes
          return
        if ui.confirmabandon
          return

          
pub TIF_setup | c, sel, fsel, sbuf, chused, chnew, chold, buf[5], image[80]
{
  NB image is TIF_max * 4 (style longs) + TIF_max * 16 (names) bytes
}
  longmove(@image, constant(cfg#setup_base + cfg#tif_styles), 80)

  ui.drawheader(string("Transaction Info Field Setup", 13,13,$C, %%2222,"      #Ch Style    Name",13), 6, 2)
  repeat sel from 0 to 7
    vid.str(string(13,"    "))
    vid.out("1"+sel)
    vid.str(string(": "))
    vid.str(bsf.rdec(image[sel] & cfg#tif_len_mask, 2))
    vid.out(" ")
    vid.str(tifbitdesc(image[sel]))
    vid.out(" ")
    vid.str(bsf.bufbuf(@image[cfg#tif_max + sel<<2], 16))
  vid.str(string(13, $C, %%2222, "       ",$90,$90,13,"          Save Changes ",$BA,$9C))    

  sel := 0
  fsel := 0
  repeat
    '
    'update characters used
    chused := 0
    repeat c from 0 to constant(cfg#tif_max - 1)
      chused += image[c] & cfg#tif_len_mask
    vid.setpos(7, 15)
    vid.str(bsf.rdec(chused, 2))
    '
    case sel
      cfg#tif_max:
        ui.hilite(10, 15, 15, 1)
        c := ui.waitkey
        ui.hilite(10, 15, 15, 0)
      other:
        case fsel
          0:
            ui.hilite(7, 6+sel, 2, 1)
            c := ui.waitkey
            ui.hilite(7, 6+sel, 2, 0)
          1:
            ui.hilite(10, 6+sel, 8, 1)
            c := ui.waitkey
            ui.hilite(10, 6+sel, 8, 0)
          2:
            ui.hilite(19, 6+sel, 16, 1)
            c := ui.waitkey
            ui.hilite(19, 6+sel, 16, 0)
    case c
      $0d:
        'edit or select
        if sel == cfg#tif_max
          'save changes
          longmove(constant(cfg#setup_base + cfg#tif_styles), @image, 80)
          savesetup
          return
        case fsel
          0:
            'edit length
            chold := image[sel] & cfg#tif_len_mask
            sf.rdec(@buf, chold, 2)
            c := ui.doinput(@buf, 7, 6+sel, 2+ui#inputnumonly)
            if c <> $CB
              'not escape
              chnew := sf.val(@buf)
              if chused - chold + chnew > 80
                ui.abortnotify(string("Total Characters Used",13,"Cannot Exceed 80.",13,"     Press [ENTER]..."))
                c := 0
                chnew := chold
              else
                chold := image[sel] & !cfg#tif_len_mask
                chold |= chnew
                image[sel] := chold
            vid.setpos(7, 6+sel)
            vid.str(bsf.rdec(chnew, 2))
            case c
              $0d:
                fsel := 1
              $c2:
                sel--
                if sel < 0
                  sel := cfg#tif_max
              $c3:
                sel++ 
          1:
            longmove(@buf, @image[cfg#tif_max + sel<<2], 4)
            byte[@buf+16] := 0
            c := edittifstyle(sel, @buf, @image[sel])
            case c
              $0D:
                fsel++
          2:
            'edit name
            longmove(@buf, @image[cfg#tif_max + sel<<2], 4)
            byte[@buf+16] := 0
            c := ui.doinput(@buf, 19, 6+sel, 16)
            if c <> $CB
              'not escape
              longmove(@image[cfg#tif_max + sel<<2], @buf, 4)
            case c
              $0d:
                fsel := 0
                sel++
              $c2:
                sel--
                if sel < 0
                  sel := cfg#tif_max
              $c3:
                sel++ 
      $C0:
        'left arrow
        if sel < cfg#tif_max
          fsel--
          if fsel < 0
            fsel := 2
      $C1:
        'right arrow
        if sel < cfg#tif_max
          fsel++
          if fsel > 2
            fsel := 0
      $c2:
         'up
        sel--
        if sel < 0
          sel := cfg#tif_max  
          fsel := 0
      $c3:
        'down
        sel++
          if sel == cfg#tif_max
            fsel := 0
          elseif sel > cfg#tif_max
            sel := 0
      $cb:
        if sf.bufcomp(constant(cfg#setup_base + cfg#tif_styles), @image, 320)
          'no changes
          return
        if ui.confirmabandon
          return


pri TIFbitDesc(style) | ptr, c, buf[3]

  ptr := 0
  repeat 8
    if (style >> (ptr + 6)) & 1
      c := lookupz(ptr:"A","U","I","~","F","~","S","X")
    else
      c := "."
    byte[@buf + ptr++] := c
  byte[@buf + ptr] := 0
  return bsf.bufstr(@buf)

pri EditTIFstyle(sel, name, ptr) | style, patt, vbuf[379]  

  vid.savescreen(@vbuf)
  vid.dimscreen(%%022)
  clock.display
  ui.hilite(4, 6+sel, 6, 1)
  vid.setpos(10, 6+sel)
  vid.str(string($c, %%2022, $b, 4, $c, %01, $9F))
  vid.str(bsf.chstr($90,26))
  vid.out($9E)
  repeat 11
    vid.str(string(13, $a, 10, $91))
    vid.str(bsf.chstr(" ",26))
    vid.out($91)
  vid.str(string(13,$a,10,$9D))
    vid.str(bsf.chstr($90,26))
  vid.out($9C)
  vid.str(string($a,11,$b,5,"TIF Field "))
  vid.out("1"+sel)
  vid.str(string(" Style",13,$a,11))
  vid.str(name)
  vid.out(":")    
  patt := ui.editbits(cfg.TIFstyleDescStr, 11, 8, long[ptr]>>6)
  vid.restorescreen(@vbuf) 
  clock.display
  if patt <> -1
    patt <<= 6
    if patt & (1 << cfg#TIF_reqin)
      patt |= (1 << cfg#tif_entin)
    if patt & (1 << cfg#TIF_reqfin)
      patt |= (1 << cfg#tif_entfin)
    patt += (long[ptr] & cfg#tif_len_mask) 
    long[ptr] := patt 
    vid.setpos(10, 6+sel)
    vid.str(tifbitdesc(patt))

pub Set_Clock | c, s, s0, edptr, edfld   

  vid.str(string(1, $C, %%2022, 7, $A, 5, $B, 5, $C, %%2222, $C, %100, "Set Clock", 13, 13, {
  } "     Use ",2,3," to Select Field",13, {
  } "     Use ",4,5," to Set Value",13,13, {
  } "     ESC = Exit"))

  edptr := 1
  edfld := 2
  s0 := $FF 'force immediate time draw
  repeat
    bkg.noclockdisplay
    if (c := key.key) <> 0
      case c
        $CB:
          return
        $C0:
          edptr := edptr - 1 #> 1
        $C1:
          edptr := edptr + 1 <# 7
        $C2:
          clock.bump(edfld, 1)
        $C3:
          clock.bump(edfld, -1)
      if cfg.sys(cfg#DateDDMM) 
        edfld := lookup(edptr:2,1,0,3,4,5,6)
      else
        edfld := lookup(edptr:2,1,0,3,5,4,6) 
      s0 := $FF 'force screen redraw
    s := tfmt.second(clock.readtime)
    if s <> s0
      'Note there is no point centering this display, since
      'there are unprinted characters for highlighting the
      'edit field which would mess up the count.
      vid.str(string($A, 5, $B, 13, $C, %%2020))
      vid.str(tfmt.setclkfmt(clock.readtime, clock.readdate, edfld))
      s0 := s
  


{
  This is intended for a device with 64K EEPROM, but this is altered to work with a demoboard
  32K saving in place instead of to high addresses and loading in place at boot.
}
pub LoadSetup | s

  return
  
  eeprom.Initialize(cfg#EE_SCL, cfg#EE_SDA)
  if (s := eeprom.readlong(eeprom#EEPROM, cfg#setup_ee_base + cfg#signature)) == cfg#EE_Signature
    vid.out("!")
    eeprom.readpage(eeprom#EEPROM, cfg#setup_ee_base, cfg#setup_base, cfg#setup_end)
  else
    vid.str(bsf.hex(s,8))
  long[cfg#setup_base + cfg#signature] := cfg#ee_signature  

pub SaveSetup | sa

  ui.screenmsg(string(13, "   Saving Changes...   ",13), %%020)
  eeprom.Initialize(cfg#EE_SCL, cfg#EE_SDA)
  sa := cfg#setup_base
  repeat while sa < constant(cfg#setup_base + cfg#setup_end)
    eeprom.writepage(eeprom#EEPROM, sa, sa, 32)
  ' eeprom.writepage(eeprom#EEPROM, sa + constant(cfg#setup_ee_base - cfg#setup_base), sa, 32)
    sa += 32
    waitcnt(cnt + clkfreq >> 4)
  waitcnt(cnt + clkfreq >> 2)       